---
title: TextTrack.mode
slug: Web/API/TextTrack/mode
tags:
  - Accessibility
  - NeedsExample
  - Property
  - TextTrack
  - Web
  - WebVTT
  - mode
---
<div>{{APIRef("WebVTT")}}</div>

<p><span class="seoSummary">The {{domxref("TextTrack")}} interface's <code><strong>mode</strong></code> property is a string specifying and controlling the text track's mode: <code>disabled</code>, <code>hidden</code>, or <code>showing</code>.</span> You can read this value to determine the current mode, and you can change this value to switch modes.</p>

<p class="note">Safari additionally requires the <code><strong>default</strong></code> boolean attribute to be set to true when implementing your own video player controls in order for the subtitles cues to be shown.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>mode</em> = <em>textTrack</em>.mode;

<em>textTrack</em>.mode = "disabled" | "hidden" | "showing";</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which indicates the track's current mode. The text track mode is one of the values listed below, under {{anch("Text track mode constants")}}.</p>

<h4 id="Text_track_mode_constants">Text track mode constants</h4>

<p>The text track mode—sometimes identified using the IDL enum <code>TextTrackMode</code>—must be one of the following values:</p>

<dl>
 <dt><code>disabled</code></dt>
 <dd>The text track is currently disabled. While the track's presence is exposed in the DOM, the user agent is otherwise ignoring it. No cues are active, no events are being fired, and the user agent won't attempt to obtain the track's cues. This is the default value, unless the text track has the {{htmlattrxref("default", "track")}} Boolean attribute is specified, in which case the default is <code>showing</code>.</dd>
 <dt><code>hidden</code></dt>
 <dd>The text track is currently active but the cues aren't being displayed. If the user agent hasn't tried to obtain the track's cues yet, it will do so soon (thereby populating the track's {{domxref("TextTrack.cues")}} property). The user agent is keeping a list of the active cues (in the track's {{domxref("TextTrack.activeCues", "activeCues")}} property) and events are being fired at the corresponding times, even though the text isn't being displayed.</dd>
 <dt><code>showing</code></dt>
 <dd>The text track is currently enabled and is visible. If the track's cues list hasn't been obtained yet, it will be soon. The {{domxref("TextTrack.activeCues", "activeCues")}} list is being maintained and events are firing at the appropriate times; the track's text is also being drawn appropriately based on the styling and the track's {{domxref("TextTrack.kind", "kind")}}. This is the default value if the text track's {{htmlattrxref("default", "track")}} Boolean attribute is specified.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The default <code>mode</code> is <code>disabled</code>, unless the {{htmlattrxref("default", "track")}} Boolean attribute is specified, in which case the default <code>mode</code> is <code>showing</code>. When a text track is loaded in the <code>disabled</code> state, the corresponding WebVTT file is not loaded until the state changes to either <code>showing</code> or <code>hidden</code>. This way, the resource fetch and memory usage are avoided unless the cues are actually needed.</p>

<p>However, that means that if you wish to perform any actions involving the track's cues while handling, for example, the {{event("load")}} event—in order to process some aspect of the cues upon page load—and the track mode was initially <code>disabled</code>, you'll have to change the <code>mode</code> to either <code>hidden</code> or <code>showing</code> in order to trigger loading of the cues.</p>

<p>When the mode is <code>showing</code>, text tracks are performed. The exact appearance and manner of that performance varies depending on each text track's {{domxref("TextTrack.kind", "kind")}}. In general:</p>

<ul>
 <li>Tracks whose <code>kind</code> is <code>"subtitles"</code> or <code>"captions"</code> are rendered with the cues overlaid over the top of the video.</li>
 <li>Tracks whose <code>kind</code> is <code>"descriptions"</code> are presented in a non-visual form (for example, the text might be spoken to describe the action in the video).</li>
 <li>Tracks whose <code>kind</code> is <code>"chapters"</code> are used by the user agent or the Web site or Web app to construct and present an interface for navigating the named chapters, where each cue in the list represents a chapter in the media. The user can then navigate to the desired chapter, which begins at the cue's start position and ends at the cue's end position.</li>
</ul>

<h2 id="Example">Example</h2>

<p>In this example, we configure the text track's cues so that every time a cue is finished, the video automatically pauses playback. This is done by setting the {{domxref("TextTrackCue.pauseonExit", "pauseOnExit")}} property on each cue to <code>true</code>. However, to ensure that the track's cues are available, we first set <code>mode</code> to <code>showing</code>.</p>

<pre class="brush: js">window.addEventListener("load", event =&gt; {
  let trackElem = document.querySelector("track");
  let track = trackElem.track;

  track.mode = "showing";

  for (let index=0; index &lt; track.cues.length; index++) {
    let cue = track.cues[index];
    cue.pauseOnExit = true;
  };
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('HTML WHATWG', '#dom-texttrack-mode', 'mode') }}</td>
   <td>{{ Spec2('HTML WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.TextTrack.mode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVTT_API">WebVTT</a></li>
 <li>{{domxref("TextTrack")}}</li>
 <li>{{domxref("TextTrackList")}}</li>
 <li>{{domxref("TextTrackCueList")}}</li>
 <li>{{domxref("VTTCue")}}</li>
 <li>{{HTMLElement("track")}}</li>
 <li>{{domxref("HTMLTrackElement")}}</li>
</ul>
